diff -uNr fwbuilder-2.1.8/build_num fwbuilder-2.1.9/build_num
--- fwbuilder-2.1.8/build_num	2006-12-03 17:44:24.000000000 +0100
+++ fwbuilder-2.1.9/build_num	2007-02-11 04:39:09.000000000 +0100
@@ -1 +1 @@
-#define BUILD_NUM 190
+#define BUILD_NUM 215
diff -uNr fwbuilder-2.1.8/configure.in fwbuilder-2.1.9/configure.in
--- fwbuilder-2.1.8/configure.in	2006-09-06 05:53:35.000000000 +0200
+++ fwbuilder-2.1.9/configure.in	2007-02-10 23:41:00.000000000 +0100
@@ -1,4 +1,4 @@
-dnl $Id: configure.in,v 1.63 2006/09/06 03:53:35 vkurland Exp $
+dnl $Id: configure.in,v 1.64 2007/02/10 22:41:00 vkurland Exp $
 
 AC_INIT(src/gui/main.cpp)
 AC_CANONICAL_SYSTEM
@@ -309,6 +309,19 @@
     DEFAULT_RES_DIR="${PREFIX}/share/fwbuilder${FWB_MAJOR_VERSION}${FWB_MINOR_VERSION}"
     ;;
 
+  *-*-kfreebsd*)
+    OS=FreeBSD
+    OS_FREEBSD=1
+    if test -f /etc/debian_version ; then
+       DISTRO=Debian
+    else
+       DISTRO="Unknown"
+    fi
+    MANDIR="${PREFIX}/share/man/"
+    AC_MSG_RESULT($DISTRO GNU/kFreeBSD)
+    DEFAULT_RES_DIR="${PREFIX}/share/fwbuilder${FWB_MAJOR_VERSION}${FWB_MINOR_VERSION}"
+    ;;
+
   *-*-linux*)
     DEFAULT_RES_DIR="${PREFIX}/share/fwbuilder${FWB_MAJOR_VERSION}${FWB_MINOR_VERSION}"
     OS=Linux
diff -uNr fwbuilder-2.1.8/doc/ChangeLog fwbuilder-2.1.9/doc/ChangeLog
--- fwbuilder-2.1.8/doc/ChangeLog	2006-12-03 17:42:24.000000000 +0100
+++ fwbuilder-2.1.9/doc/ChangeLog	2007-02-10 23:49:08.000000000 +0100
@@ -1,3 +1,210 @@
+2007-02-10  vadim  <vadim@vk.crocodile.org>
+
+	* v2.1.9 release
+	
+	* main.cpp (tty_raw): bug #1650369: "[patch] please add support
+	for GNU/kFreeBSD". Applied patch to make code compile on kFreeBSD.
+
+2007-02-03  vadim  <vadim@vk.crocodile.org>
+
+	* listOfLibraries.cpp (list): fixed bug #1620284: "conflict when
+	adding library to Preferences/Libraries". When the user tried to
+	add a library to the list in Preferemces/Libraries when a data
+	file with the same object library was loaded, the GUI detected the
+	conflict and showed error dialog.
+
+	* FWWindow.cpp (FWWindow::fileCompare): New feature: new operation
+	"Tools/Find Conflicting Objects in Two Data Files". This operation
+	inspects two data files (either .fwb or .fwl) and finds
+	conflicting objects. Conflicting objects have the same internal ID
+	but different attributes. Two data files can not be merged, or one
+	imported into another, if they contain such objects. This
+	operation also helps identify changes made to objects in two
+	copies of the same data file. This operation does not find objects
+	present in one file but not in the other, such objects present no
+	problem for merge or import operations. This operation works with
+	two external files, neither of which needs to be opened in the
+	program. Currently opened data file is not affected by this
+	operation and objects in the tree do not change. In the process of
+	this operation user is presented with series of dialogs showing
+	conflicting objects side by side. In the end the program can
+	generate report and write it to a text file.
+
+2007-01-30  vadim  <vadim@vk.crocodile.org>
+
+	* instDialog.cpp (instDialog::initiateCopy): more for the bug
+	#1617501:"Install fails after compile". Making sure we always
+	strip directory path from the file name if user specified full
+	path for the policy file in the "Output file name" input field in
+	the "Compiler" tab of firewall object dialog. Need to strip path
+	when macro "%FWSCRIPT%" is substituted in installation scriptlets
+	and in some other places.
+
+2007-01-15  vadim  <vadim@vk.crocodile.org>
+
+	* OSConfigurator_linux24.cpp (linux24::printRunTimeWrappers): 
+	fixed bug (no num.): data files used for run-time AddressTable
+	objects can have empty lines, the script should skip them.
+
+2007-01-14  vadim  <vadim@vk.crocodile.org>
+
+	* iptAdvancedDialog.cpp (iptAdvancedDialog::iptAdvancedDialog):
+	more for bug #1618381: "CLASSIFY/MARK are non-terminating".
+	Emulation of the terminating behavior for Classify and Tag actions
+	is now controlled by a global option in the "Compiler" tab of the
+	firewall properties dialog. This means emulation can be turned on
+	and off for all rules that might require it at once. It is
+	impossible to mix such rules with terminating and non-termninating
+	behavior. The reason for this is that shadowing detection
+	algorithm can only work with either terminating or non-terminating
+	rules, not with the mix. Hopefully this is the last change made
+	for this bug.
+
+	* PolicyCompiler_ipt.cpp (ipt::getAddressTableVarName): fixed bug
+	#1632054: "Runtime AddressObjects FAIL to load if "Name:" contains
+	"."". Compiler checks if the name of the run-time AddressTable
+	object contains characters that have special meaning in sheel and
+	relaces them with '_' when it generates the name of the temporary
+	shell variable.
+
+	* PolicyCompiler_ipt.cpp (splitNonTerminatingTargets): update for
+	bug #1618381: "CLASSIFY/MARK are non-terminating". Adding iptables
+	rule with target ACCEPT to make Tag and Classify rules
+	terminating. This is controlled by checkbox in the action dialog
+	for actions Classify and Tag. Default setting is off.
+
+2007-01-09  vadim  <vadim@vk.crocodile.org>
+
+	* FWWindow.cpp (FWWindow::scheduleRuleSetRedraw): fixed bug (no
+	num.): GUI used show fanthom 'Policy', 'NAT' and 'Routing' tabs
+	when user deleted objects from the Deleted Objects library,
+	provided some of these objects were previously deleted firewalls.
+
+2007-01-07  vadim  <vadim@vk.crocodile.org>
+
+	* GroupObjectDialog.cpp (GroupObjectDialog::dropped): fixed bug
+	#1624577: "group window doesn't stay open on multiple-adds". Using
+	special flag to tell ObjectTreeView that it should ignore
+	MouseReleaseEvent it gets after d&d operation, so it wont switch
+	object in the editor panel. Note the bug triggered only on Mac OS
+	X.
+
+	* FWWindow.cpp (FWWindow::FWWindow): "Apply" and "Close" buttons
+	in the objct editor panel should be of fixed size horizontally
+
+2007-01-06  vadim  <vadim@vk.crocodile.org>
+
+	* instDialog.cpp (instDialog::testFirewall): fixed bug
+	#1617501:"Install fails after compile". The GUI got confused when
+	user enter full path to the policy file in the "Output file name"
+	input field in the "Compiler" tab of firewall object dialog.
+
+	* SimpleTextEditor.cpp (SimpleTextEditor::loadFromFile): fixed bug
+	1619930: "Prolog tab's ScriptEditor's import fails to overwrite"
+
+	* OSConfigurator_linux24.cpp (linux24::printRunTimeWrappers):
+	fixed bug #1628989: "run-time-loaded rules don't accept ";" as
+	line comment"
+
+	* RuleOptionsDialog.cpp (RuleOptionsDialog::changed): fixed bug
+	#1620206: "RuleOptions' "Apply" button greyed-out until menu
+	selection"
+
+	* SimpleTextEditor.cpp (SimpleTextEditor::SimpleTextEditor): fixed
+	bug #1619842: "prolog "script editor" opens behind other windows"
+
+	* RuleSetView.cpp (RuleSetView::removeRule): fixed bug #1629521:
+	"can't delete empty chain/policy tab"
+
+	* instOptionsDialog.cpp (instOptionsDialog::hidePIXOptions):
+	installOptionsDialog was too large and did not fit on some laptop
+	screens. Doing tricks to make sure the dialog properly resized
+	after unused GUI elements are hidden.
+	
+
+2007-01-04  vadim  <vadim@vk.crocodile.org>
+
+	* PolicyCompiler.cpp (DetectShadowingForNonTerminatingRules::processNext):
+	(API change)
+	fixed bug #1618381: "CLASSIFY/MARK are non-terminating". Non-terminating
+	rules shadow each other "backwards", that is more general rule
+	shadows other rules _above_ it. Added flag 'reverse' to the method
+	find_more_general_rule and added new rule processor
+	DetectShadowingForNonTerminatingRules that finds such cases of
+	'reverse' shadowing. Using it for rules in the mangle table for iptables.
+
+	
+	* PolicyCompiler_ipt.cpp (finalizeChain::processNext): working on
+	bug #1618381
+
+	 * For action Branch with option to add branching rule to the
+	 mangle table: we now generate rules in PREROUTING, POSTROUTING,
+	 INPUT, OUTPUT and FORWARD chains. This is because some targets
+	 can only work in PREROUTING or POSTROUTING chains but we do not
+	 know what rules will user put in the branch. So we need to branch
+	 in all chains
+
+	 * For rules in mangle table with direction set to Inbound or
+	 Outbound force chain to PREROUTING or POSTROUTING respectively
+	 early. This eliminates duplicates such as the same rule in
+	 PREROUTING and INPUT chains. Also since most (all?) targets that
+	 require mangle table go into either PREROUTING or POSTROUTING
+	 chains, it should be enough to use these two chains.
+
+2007-01-01  vadim  <vadim@vk.crocodile.org>
+
+
+	* ActionsDialog.cpp (ActionsDialog::setRule),
+	PolicyCompiler_ipt.cpp (splitNonTerminatingTargets::processNext):
+	working on bug #1618381: "CLASSIFY/MARK are
+	non-terminating". Converting non-terminating targets MARK and
+	CLASSIFY into equivalent of terminating targets using intermediate
+	chain and "-g" option to pass control to it. Added a checkbox to
+	the rule options dialog for action Classify for this, by default
+	this feature is off.
+	
+
+2006-12-27  vadim  <vadim@vk.crocodile.org>
+
+	* Compiler.cpp (Compiler::expandGroupsInRuleElement): fixed bug
+	#1620925: "compile-time AddressTable object with empty file".
+	Compile-time AddressTable object that uses file with no addresses
+	should be treated as an empty group according to the "Ignore empty
+	groups" option. Changes are made as follows:
+
+	 - Compiler::expandGroupsInRuleElement does not call
+	s->setAnyElement(); to set rule element to 'any' before adding
+	addresses from the group. This means that if group is empty, rule
+	element remains empty (not even 'any', just with no children,
+	i.e. with size()==0).  Note that AddressTable::loadFromSource()
+	leaves AddressTable object empty if the file does not have any
+	addresses.
+
+	 - Compiler::emptyGroupsInRE specifically checks for run-time
+	MultiAddress objects and skips them so they wont be treated as
+	empty groups (since they are indeed empty). Compile-time
+	MultiAddress objects are treated as groups and algorithm that
+	depends on option 'ignore empty groups' is executed for both empty
+	regular groups and empty compile-time MultiAddress objects.
+
+	* PolicyCompiler_ipt_optimizer.cpp (optimize1::optimizeForRuleElement):
+	fixed bug #1623113: 'connlimit fails in compiled "address table" rules'
+	Module connlimit can only be used in iptables rules matching TCP services.
+	Such iptables commands have "-p tcp" and/or "-m tcp" options. If
+	a rule in fwbuilder uses TCP Service and connlimit option and has
+	multiple objects in src and dst, optimizer used to split it to minimize 
+	matches. It however preserved connlimit option in all subrules,
+	even though some of them did not have TCP service after the split. This
+	lead to generation of incorrect iptables commands.
+	
+	* PolicyCompiler_ipt.cpp (Branching::expandBranch): fixed bug
+	#1623338: "Can not disable rules in a branch". Compiler for
+	iptables ignored flag 'disabled' on rules in a branch.
+
+2006-12-26  vadim  <vadim@vk.crocodile.org>
+
+	* VERSION (FWB_MICRO_VERSION): set version to 2.1.9
+
 2006-12-03  vadim  <vadim@vk.crocodile.org>
 
 	* v2.1.8 released
diff -uNr fwbuilder-2.1.8/fwbuilder2.spec fwbuilder-2.1.9/fwbuilder2.spec
--- fwbuilder-2.1.8/fwbuilder2.spec	2006-12-03 17:44:36.000000000 +0100
+++ fwbuilder-2.1.9/fwbuilder2.spec	2007-02-11 04:39:22.000000000 +0100
@@ -1,6 +1,6 @@
 
 %define name    fwbuilder
-%define version 2.1.8
+%define version 2.1.9
 %define release 1
 %define BUILD_VERSION 21
 
@@ -24,8 +24,9 @@
 
 Buildroot:      %{_tmppath}/%{name}-%{version}-root
 
-Requires:      libfwbuilder = 2.1.8
-BuildRequires: libfwbuilder-devel = 2.1.8
+Requires:      libfwbuilder = 2.1.9
+BuildRequires: libfwbuilder-devel = 2.1.9
+BuildRequires: libxml2-devel, libxslt-devel
 %if "%_vendor" == "redhat"
 BuildRequires: qt-devel
 %else
diff -uNr fwbuilder-2.1.8/po/POmakefile fwbuilder-2.1.9/po/POmakefile
--- fwbuilder-2.1.8/po/POmakefile	2006-12-03 17:44:33.000000000 +0100
+++ fwbuilder-2.1.9/po/POmakefile	2007-02-11 04:39:19.000000000 +0100
@@ -94,7 +94,7 @@
 STRIP = @STRIP@
 UIC = @UIC@
 USE_NLS = yes
-VERSION = 2.1.8
+VERSION = 2.1.9
 X_CFLAGS = @X_CFLAGS@
 X_EXTRA_LIBS = @X_EXTRA_LIBS@
 X_LIBS = @X_LIBS@
diff -uNr fwbuilder-2.1.8/qmake.inc fwbuilder-2.1.9/qmake.inc
--- fwbuilder-2.1.8/qmake.inc	2006-12-03 17:44:33.000000000 +0100
+++ fwbuilder-2.1.9/qmake.inc	2007-02-11 04:39:18.000000000 +0100
@@ -17,7 +17,7 @@
     OBJECTS_DIR = .obj
 
 	PREFIX                  = /usr/local
-	DOCDIR                  = /usr/local/share/doc/fwbuilder-2.1.8
+	DOCDIR                  = /usr/local/share/doc/fwbuilder-2.1.9
 	MANDIR                  = /usr/local/share/man/
 	LIBS_FWCOMPILER         = -pthread -lfwcompiler -lfwbuilder -lxslt -lxml2 -lz -lnetsnmp -lelf -lm -lssl -lcrypto
 	LIBS_FWBUILDER          = -pthread -lfwbuilder -lxslt -lxml2 -lz -lnetsnmp -lelf -lm -lssl -lcrypto
diff -uNr fwbuilder-2.1.8/src/gui/ActionsDialog.cpp fwbuilder-2.1.9/src/gui/ActionsDialog.cpp
--- fwbuilder-2.1.8/src/gui/ActionsDialog.cpp	2006-10-24 05:43:24.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/ActionsDialog.cpp	2007-01-15 05:37:51.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Illiya Yalovoy <yalovoy@gmail.com>
 
-  $Id: ActionsDialog.cpp,v 1.23 2006/10/24 03:43:24 vkurland Exp $
+  $Id: ActionsDialog.cpp,v 1.28 2007/01/15 04:37:51 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -134,7 +134,7 @@
 
     if (editor=="BranchChain" || editor=="BranchAnchor")
     {
-        mw->setPolicyBranchTabName(rule);
+        mw->setPolicyBranchTabName(rule->getBranch());
     }
 
     if (useDummyNetPipe->isChecked())
@@ -210,10 +210,35 @@
         useDummyNetQueue->setChecked(1);
     }
 
+    if (platform=="iptables")
+    {
+        classify_txt_1->show();
+        classify_terminating->show();
+        tag_txt_1->show();
+        tag_terminating->show();
+
+        if (firewall->getOptionsObject()->getBool ("classify_mark_terminating"))
+        {
+            classify_terminating->setText(tr("Emulation is currently ON, rule will be terminating") );
+            tag_terminating->setText(tr("Emulation is currently ON, rule will be terminating") );
+        } else
+        {
+            classify_terminating->setText(tr("Emulation is currently OFF, rule will be non-terminating") );
+            tag_terminating->setText(tr("Emulation is currently OFF, rule will be non-terminating") );
+        }
+
+    } else
+    {
+        classify_txt_1->hide();
+        classify_terminating->hide();
+        tag_txt_1->hide();
+        tag_terminating->hide();
+    }
+
     data.clear();
 
     data.registerOption ( ipt_mark_connections, ropt , "ipt_mark_connections");
-    data.registerOption ( ipt_mark_prerouting,  ropt , "ipt_mark_prerouting");
+    data.registerOption ( ipt_mark_prerouting , ropt , "ipt_mark_prerouting");
     data.registerOption ( accountingvalue_str , ropt , "rule_name_accounting");
     data.registerOption ( usePortNum          , ropt , "ipfw_pipe_queue_num");
     data.registerOption ( divertPortNum       , ropt , "ipfw_pipe_port_num");
diff -uNr fwbuilder-2.1.8/src/gui/actionsdialog_q.ui fwbuilder-2.1.9/src/gui/actionsdialog_q.ui
--- fwbuilder-2.1.8/src/gui/actionsdialog_q.ui	2006-09-13 17:46:46.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/actionsdialog_q.ui	2007-01-15 05:37:51.000000000 +0100
@@ -8,8 +8,8 @@
         <rect>
             <x>0</x>
             <y>0</y>
-            <width>562</width>
-            <height>255</height>
+            <width>697</width>
+            <height>356</height>
         </rect>
     </property>
     <property name="caption">
@@ -307,41 +307,7 @@
                                     <property name="name">
                                         <cstring>unnamed</cstring>
                                     </property>
-                                    <spacer row="4" column="0">
-                                        <property name="name">
-                                            <cstring>spacer31</cstring>
-                                        </property>
-                                        <property name="orientation">
-                                            <enum>Vertical</enum>
-                                        </property>
-                                        <property name="sizeType">
-                                            <enum>Expanding</enum>
-                                        </property>
-                                        <property name="sizeHint">
-                                            <size>
-                                                <width>20</width>
-                                                <height>20</height>
-                                            </size>
-                                        </property>
-                                    </spacer>
-                                    <spacer row="0" column="0">
-                                        <property name="name">
-                                            <cstring>spacer30</cstring>
-                                        </property>
-                                        <property name="orientation">
-                                            <enum>Vertical</enum>
-                                        </property>
-                                        <property name="sizeType">
-                                            <enum>Expanding</enum>
-                                        </property>
-                                        <property name="sizeHint">
-                                            <size>
-                                                <width>20</width>
-                                                <height>20</height>
-                                            </size>
-                                        </property>
-                                    </spacer>
-                                    <widget class="QLayoutWidget" row="1" column="0">
+                                    <widget class="QLayoutWidget" row="0" column="0">
                                         <property name="name">
                                             <cstring>layout3</cstring>
                                         </property>
@@ -398,7 +364,7 @@
                                             </spacer>
                                         </hbox>
                                     </widget>
-                                    <widget class="QCheckBox" row="2" column="0">
+                                    <widget class="QCheckBox" row="1" column="0">
                                         <property name="name">
                                             <cstring>ipt_mark_connections</cstring>
                                         </property>
@@ -409,7 +375,7 @@
                                             <string>Requires CONNMARK target</string>
                                         </property>
                                     </widget>
-                                    <widget class="QCheckBox" row="3" column="0">
+                                    <widget class="QCheckBox" row="2" column="0">
                                         <property name="name">
                                             <cstring>ipt_mark_prerouting</cstring>
                                         </property>
@@ -417,6 +383,45 @@
                                             <string>Mark packets in PREROUTING chain</string>
                                         </property>
                                     </widget>
+                                    <spacer row="5" column="0">
+                                        <property name="name">
+                                            <cstring>spacer31</cstring>
+                                        </property>
+                                        <property name="orientation">
+                                            <enum>Vertical</enum>
+                                        </property>
+                                        <property name="sizeType">
+                                            <enum>Expanding</enum>
+                                        </property>
+                                        <property name="sizeHint">
+                                            <size>
+                                                <width>20</width>
+                                                <height>20</height>
+                                            </size>
+                                        </property>
+                                    </spacer>
+                                    <widget class="QLabel" row="3" column="0">
+                                        <property name="name">
+                                            <cstring>tag_txt_1</cstring>
+                                        </property>
+                                        <property name="text">
+                                            <string>Note: this action translates into MARK target for iptables. Normally this target is non-terminating, that is, other rules with Classify or Tag actions belog this one will process the same packet. However, Firewall Builder can emulate terminating behavior for this action. Option in the "compiler" tab of the firewall object properties dialog activates emulation.</string>
+                                        </property>
+                                        <property name="alignment">
+                                            <set>WordBreak|AlignVCenter</set>
+                                        </property>
+                                    </widget>
+                                    <widget class="QLabel" row="4" column="0">
+                                        <property name="name">
+                                            <cstring>tag_terminating</cstring>
+                                        </property>
+                                        <property name="text">
+                                            <string>Emulation is currently ON, the rule will be terminating</string>
+                                        </property>
+                                        <property name="alignment">
+                                            <set>AlignCenter</set>
+                                        </property>
+                                    </widget>
                                 </grid>
                             </widget>
                             <widget class="QWidget">
@@ -667,28 +672,11 @@
                                 <attribute name="id">
                                     <number>7</number>
                                 </attribute>
-                                <vbox>
+                                <grid>
                                     <property name="name">
                                         <cstring>unnamed</cstring>
                                     </property>
-                                    <spacer>
-                                        <property name="name">
-                                            <cstring>spacer5</cstring>
-                                        </property>
-                                        <property name="orientation">
-                                            <enum>Vertical</enum>
-                                        </property>
-                                        <property name="sizeType">
-                                            <enum>Expanding</enum>
-                                        </property>
-                                        <property name="sizeHint">
-                                            <size>
-                                                <width>20</width>
-                                                <height>21</height>
-                                            </size>
-                                        </property>
-                                    </spacer>
-                                    <widget class="QLabel">
+                                    <widget class="QLabel" row="0" column="0">
                                         <property name="name">
                                             <cstring>textLabel2_3</cstring>
                                         </property>
@@ -696,14 +684,25 @@
                                             <string>Classify string:</string>
                                         </property>
                                     </widget>
-                                    <widget class="QLineEdit">
+                                    <widget class="QLineEdit" row="1" column="0">
                                         <property name="name">
                                             <cstring>classify_str</cstring>
                                         </property>
                                     </widget>
-                                    <spacer>
+                                    <widget class="QLabel" row="2" column="0">
                                         <property name="name">
-                                            <cstring>spacer6</cstring>
+                                            <cstring>classify_txt_1</cstring>
+                                        </property>
+                                        <property name="text">
+                                            <string>Note:  CLASSIFY target in iptables is non-terminating, that is other rules with Classify or Mark target below this will process the same packet. However, Firewall Builder can emulate terminating behavior for this action. Emulation is activated by an option in the "compiler" tab of the firewall object properties dialog.</string>
+                                        </property>
+                                        <property name="alignment">
+                                            <set>WordBreak|AlignVCenter</set>
+                                        </property>
+                                    </widget>
+                                    <spacer row="4" column="0">
+                                        <property name="name">
+                                            <cstring>spacer31_2</cstring>
                                         </property>
                                         <property name="orientation">
                                             <enum>Vertical</enum>
@@ -714,11 +713,22 @@
                                         <property name="sizeHint">
                                             <size>
                                                 <width>20</width>
-                                                <height>31</height>
+                                                <height>20</height>
                                             </size>
                                         </property>
                                     </spacer>
-                                </vbox>
+                                    <widget class="QLabel" row="3" column="0">
+                                        <property name="name">
+                                            <cstring>classify_terminating</cstring>
+                                        </property>
+                                        <property name="text">
+                                            <string>Emulation is currently ON, rule will be terminating</string>
+                                        </property>
+                                        <property name="alignment">
+                                            <set>AlignCenter</set>
+                                        </property>
+                                    </widget>
+                                </grid>
                             </widget>
                             <widget class="QWidget">
                                 <property name="name">
